/* Multiple-precision version of the 3x+1 calculation, processing */
/* integers n == 3 (mod 4).					  */

/* In PROCESS OF MAKING PARALLEL  **********/


#include "miarith.h"
#include <stdio.h>
#include "timer.h"

/* System precision, array size */
#define P  4
#define P1 5
#define DP ((30*P + 4)/3)

#define NC = 8  
shape [NC] classes;
int:classes XO[P1], X[P1], step[P1], One[P1], C, Cmax;


/* the following chunk of code is commented out (from nonparall. prog)....

int X0[P1],	/* Starting value for current sequence	*/
/*    X[P1],	/* Current sequence value		*/
/*    step[P1],	/* Amount to advance X0			*/
/*    One[P1];	/* For increments			*/    

/* int C,		/* Number of steps in current sequence	*/
/*    Cmax;	/* Maximum number of steps to stopping	*/


/* Initialize search	*/

void start()
 { pmzero(X0, P);    X0[0] = 4;    X0[P] = 3;	/* X0 = 3	*/
   pmcopy(X, X0, P);				/* X  = X0	*/
   pmzero(step, P);  step[0] = 4;  step[P] = 4;	/* step = 4	*/
   pmzero(One, P);   One[0] = 4;   One[P] = 1;	/* One = 1	*/
   Cmax = C = 0;
   printf("Initialized with X0 = 3, step = 4\n");
 }


/* Report cycle	*/

void report_cycle()
 { char X0d[80];
   pim2dec(X0, P, X0d, DP);
   printf("CYCLE DETECTED AT\n X0 = %s\n C = %d\n", X0d, C);
 }


/*  Artificial test of report_cycles.  The program is careful to avoid	*/
/*  any net change of the computation state.				*/

void testrc()
 { printf("Test of cycle report.\n");
   report_cycle();
 }


/*  Perform n steps of calculation.  */


void stepper(int n)
 { int k,int:current cmp;
   int Y[P1];	/* Working value for {x, 3x+1}/2	*/
   for ( k = 0;  k < n;  k++ )
    { pimshift(Y, X, -1, P);		/* Y = X/2	*/
      where ( X[P]&1 )
       { pimadd(X, X, Y, P);
	 pimadd(X, X, One, P);		/* X = X+Y+1	*/
      else  
	 pmcopy(X, Y, P);		/* X = Y	*/
      C++;				/* Count step	*/
      cmp = pimcomp(X, X0, P);		/* Compare	*/
      where ( cmp == 0 )			/* if X == X0	*/ 
	 report_cycle();
      where ( cmp  < 0 )			/* if X < X0	*/
       { pimadd(X0, X0, step, P);	/* X0 = X0+step	*/
	 pmcopy(X, X0, P);		/* X = X0	*/
	 where ( C > Cmax ) Cmax = C;	/* New longest	*/
	 C = 0;				/* Reset	*/
       }
    }	/* end for	*/
 }	/* end stepper	*/


/* Run n calculation cycles, report results.	*/

void run(int n)
 { char Yd[80];  int:current Y[P1];
   Tim_clear();  Tim_start();
   stepper(n);
   pimsub(Y, X0, One, P);		/* Y = X0 - 1	*/
   pim2dec(Y, P, Yd, DP);
   Tim_stop();  Tim_report();
   printf("Confirmed to\n   %s\nlongest seq = %d\n", Yd, Cmax);
 }


/* Report state of calculation */

void report_state()
 { char Xd[80];
   pim2dec(X0, P, Xd, DP);  printf("X0 = %s\n", Xd);
   pim2dec(X,  P, Xd, DP);  printf("X  = %s\n", Xd);
   printf("Cmax = %11d    C = %11d\n", Cmax, C);
 }


/*  Main program which manages interactive experiments	*/
/*  Commands are:					*/
/*		  r <n>	- run n steps			*/
/*		  i	- (re)initialize calculation	*/
/*		  s	- report complete state		*/
/*		  t	- test cycle report		*/
/*		  q	- quit				*/

void main()
 { int ns;  char buff[80];
   printf("3x+1 calculation, %d char's for decimal.\n", DP);
   while ( printf("3x+1> "),  scanf("%s", buff),  buff[0] != 'q' )
   switch ( buff[0] )
     { case 'r':  scanf("%d", &ns);  
		  if ( X0[P]&1 ) run(ns);
		    else
		     printf("Calculation isn't initialized properly.\n");
		  break;
       case 'i':  start(); break;
       case 's':  report_state(); break;
       case 't':  testrc(); break;
       default:   printf("Bad input -- ignored.\n"); break;
     }
 }
